/*
                          ech3_completo.c

Conversione di file di echo in un file leggibile

Il file di input deve essere un file di echo (ad esempio un file
creato con lo scanner della Cyberware.
Il file di output sar chiamato input.ech.

*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>

int **imatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
	int i,**m;

	m=(int **)malloc((unsigned) (nrh-nrl+1)*sizeof(int*));
	if (!m) printf("Allocazione 1 fallita in imatrix()");
	m -= nrl;

	for(i=nrl;i<=nrh;i++) {
		m[i]=(int *)malloc((unsigned) (nch-ncl+1)*sizeof(int));
		if (!m[i]) printf("Allocazione 2 fallita in imatrix()");
		m[i] -= ncl;
	}
	return m;
}

main(argc,argv)
int argc;
char *argv[];
{

FILE *fp_in, *fp_out, *fp_imm;
char infile[32],
     outfile[32],
     immfile[32],
     c,
     a,
     dato_char[65536],
     lunghezza_mappa[4];

unsigned short u;

int **z,
    **imatrix(),
    int_a,
    header,		  // Lunghezza header del file delle profondit
    i,j,contatore,                  /* Indici */
    xposts,               /* Numero di punti in X */
    yposts,               /* Numero di punti in Y */
    n,                    /* Totale dei punti xposts*yposts */
    s,
    range,                /* Dimensione della scansione */
    passo_della_i,        /* Passo della lg in micron */
    dato_colore[65536],   /* Dati della mappa */
    immagine[512][512],   /* Immagine in scala di grigi */
    lunghezza_mappa_int;


/* Test degli argomenti */
if ( argc == 1 )
        { printf("Devi dare un argomento\n");
          exit(1);
};

/* File di input */
strcpy(infile,argv[1]);
if ((fp_in = fopen (infile, "r")) == NULL)
   { printf("File di input inesistente\n"); exit(); };

/* File di output */
strcpy(outfile,argv[1]);
strcat(outfile,".ech");


xposts=512; yposts=512;
n=xposts*yposts;

/* Richiede il range di scansione */
  do {
  printf("\n\nInserire il range di scansione (150, 256, 384 mm): ");
  scanf("%d", &range);
  printf("\n");
}

/* Controlla esattezza del range */
while (range!=150 && range!=256 && range!=384);


/* Definizione della matrice delle profondit */
z = imatrix ( 0, xposts-1, 0, yposts-1 );

header = strlen( argv[1] ) + 252;
for (j=0;j<header;j++){
	fscanf(fp_in,"%c",&c);
}


/* Matrice delle profondit */
for (i=0;i<xposts;i++){
for (j=0;j<yposts;j++){
        fscanf(fp_in,"%2c",&u);
        z[i][j]=8*(int)u;

	if (z[i][j] > 262144) 		
		z[i][j] = - 65536 * 8 + z[i][j];
	
}};

/* Chiusura del file di input */
fclose (fp_in);


/* Preleva dati colore dal file sunraster */

/* File sun */
strcpy(immfile,argv[1]);
strcat(immfile,".sun");


/* Apre il file sunraster */
if ((fp_imm = fopen (immfile, "r")) == NULL)
   { printf("File sun di input inesistente\n"); exit(); };

/* Salta l'header che non interessa */
for (j=0;j<28;j++){
	fscanf(fp_imm,"%c",&c);
}

/* Legge la lunghezza della mappa */
for (j=0;j<4;j++){
	fscanf(fp_imm,"%c",&lunghezza_mappa[j]);
}
lunghezza_mappa_int=lunghezza_mappa[3]+
                    lunghezza_mappa[2]*256+
                    lunghezza_mappa[1]*65536+
                    lunghezza_mappa[0]*16777216;


/* Legge la mappa */
for (contatore=0;contatore<lunghezza_mappa_int;contatore++){
	fscanf(fp_imm,"%c",&dato_char[contatore]);
        dato_colore[contatore]=dato_char[contatore];
}


/* Matrice dell'immagine */
for (i=0;i<xposts;i++){
for (j=0;j<yposts;j++){
	fscanf(fp_imm,"%c", &a);
        int_a=(int)a;
	immagine[i][j]=dato_colore[int_a];
}};


/* Chiude il file sun */
fclose (fp_imm);


/* Scrittura sul file
   x e y vengono dati in micrometri */

/* L'incremento della i deve essere di
       293  per le scansioni di 150 mm
       500  per le scansioni di 256 mm
       750  per le scansioni di 384 mm
*/

switch (range) {

  case 150: { passo_della_i=293;
              break; }

  case 256: { passo_della_i=500;
              break; }

  case 384: { passo_della_i=750;
              break; }
}


fp_out = fopen (outfile,"w");

for (i=0;i<xposts;i++){
for (j=0;j<yposts;j++){
      if (z[i][j] == 262144) continue;
      fprintf(fp_out,"%d,%d,%d,%d\n", \
	       (i*passo_della_i), \
		    (j*300), \
                             z[i][j], \
				immagine[i][j]  );
}}
fclose (fp_out);


}

