/*
                          ech6_wrl2.c

Conversione del file di echo in un file per visualizzatore 3D.

Il file di input deve essere un file di echo, ad esempio un file prele-
vato con lo scanner della Cyberware.
Rispetto al ech5, prende un punto s ed uno no. Inoltre divide z per 10.
L'output sar un file chiamato input.2.wrl.

*/ 

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>

int **imatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
	int i,**m;

	m=(int **)malloc((unsigned) (nrh-nrl+1)*sizeof(int*));
	if (!m) printf("Allocazione 1 fallita in imatrix()");
	m -= nrl;

	for(i=nrl;i<=nrh;i++) {
		m[i]=(int *)malloc((unsigned) (nch-ncl+1)*sizeof(int));
		if (!m[i]) printf("Allocazione 2 fallita in imatrix()");
		m[i] -= ncl;
	}
	return m;
}

main(argc,argv)
int argc;
char *argv[];
{
/****************** Dichiarazioni ************************/
FILE *fp_in, *fp_out, *fp_imm;
char infile[32], 
     outfile[32],
     immfile[32],
     c,
     a;

unsigned short u;

int **z,
    **imatrix(),
    int_a,
    header,		  // Lunghezza header del file delle profondit
    i,j,				/* Indici */
    xposts,               /* Numero di punti lungo la direzione X */
    yposts,               /* Numero di punti lungo la direzione Y */
    n,                    /* Totale dei punti xposts*yposts */
    s,
    range,                /* Dimensione della scansione */
    passo_della_i;        /* Passo della lg in micron */
/****************** Fine delle dichiarazioni *******************/


/* Test degli argomenti */
if ( argc == 1 )
        { printf("Devi dare un argomento\n");
          exit(1);
};

/* File di input */
strcpy(infile,argv[1]);
if ((fp_in = fopen (infile, "r")) == NULL)
   { printf("File inesistente\n"); exit(); };

/* File di output */
strcpy(outfile,argv[1]);
strcat(outfile,".2.wrl");


xposts=512; yposts=512;
n=xposts*yposts;

/* Richiede il range di scansione */
  do {
  printf("\n\nInserire il range di scansione (150, 256, 384 mm): ");
  scanf("%d", &range);
  printf("\n");
}

/* Controlla esattezza del range */
while (range!=150 && range!=256 && range!=384);


/* Definizione della matrice delle profondit */
z=imatrix(0,xposts-1,0,yposts-1);

header = strlen( argv[1] ) + 252;
for (j = 0; j < header; j++){
	fscanf(fp_in,"%c",&c);
}

/* Matrice delle profondit */
for (i=0;i<xposts;i++){
for (j=0;j<yposts;j++){
        fscanf(fp_in,"%2c",&u);
        z[i][j]=8*(int)u;

	if (z[i][j] > 262144)
		z[i][j] = - 65536 * 8 + z[i][j];
}};

/* Chiusura del file di input */
fclose (fp_in);


/* Write to file
   x e y vengono dati in micrometri */

/* l'incremento della i deve essere di
       293  per le scansioni di 150 mm
       500  per le scansioni di 256 mm
       750  per le scansioni di 384 mm
*/

switch (range) {

  case 150: { passo_della_i=293;
              break; }

  case 256: { passo_della_i=500;
              break; }

  case 384: { passo_della_i=750;
              break; }
}


fp_out = fopen (outfile,"w");

fprintf(fp_out,"#VRML V2.0 utf8\n");
fprintf(fp_out,"#Insiemi di punti\n\n");
fprintf(fp_out,"PointSet {\n\n");
fprintf(fp_out,"   coord Coordinate {\n");
fprintf(fp_out,"                    point [\n");
for (i = 0; i < xposts; i = i + 2){
for (j = 0; j < yposts; j = j + 2){
      if (z[i][j] == 262144) continue;
      fprintf(fp_out,"				%d %d %d,\n", \
	       (i * passo_della_i), \
		    (j * 300), \
                             z[i][j] / 10);
}}
fprintf(fp_out,"                          ]\n");
fprintf(fp_out,"                     }\n               }");
fclose (fp_out);


}
