/*
                                 sti.c

Stira files Echo 3D dopo averli convertiti in un formato
leggibile da questo programma.

Il file di input contenente i dati di profondit deve essere nel
formato standard di Echo, ad esempio un file creato dallo
scanner Cyberware.
Il file dei colori deve essere in formato sunraster a scala di grigi.
L'output sar un file nominato input_sti.ras.

*/


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>


int **imatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
	int i,**m;

	m=(int **)malloc((unsigned) (nrh-nrl+1)*sizeof(int*));
	if (!m) printf("Allocazione 1 fallita in imatrix()");
	m -= nrl;

	for(i=nrl;i<=nrh;i++) {
		m[i]=(int *)malloc((unsigned) (nch-ncl+1)*sizeof(int));
		if (!m[i]) printf("Allocazione 2 fallita in imatrix()");
		m[i] -= ncl;
	}
	return m;
}




main(argc,argv)

#define PASSO_DELLA_J 300
#define XPOSTS 512	// Dimensione X dell'immagine
#define YPOSTS 512	// Dimensione Y dell'immagine

int argc;
char *argv[];
{

FILE *fp_in, *fp_out, *fp_imm;
char infile[32],
     outfile[32],
     immfile[32],
     c,
     a,
     dato_char[65536],
     lunghezza_mappa[4];

unsigned short u;


double alfa_righe[XPOSTS][YPOSTS],
       alfa_colonne[XPOSTS][YPOSTS],
       distanza_righe[XPOSTS][YPOSTS],
       distanza_colonne[XPOSTS][YPOSTS],
       distanza_vera_righe[XPOSTS][YPOSTS],
       distanza_vera_colonne[XPOSTS][YPOSTS];


int **z,
    **imatrix(),
    int_a,
    header,		  // Lunghezza header del file delle profondit
    i,j,contatore,                    // Indici
    s,
    range,                // Dimensione della scansione
    passo_della_i,        // Passo della lg in micron
    dato_colore[65536],   // Dati della mappa
    immagine[XPOSTS][YPOSTS],   // Immagine in scala di grigi
    immagine_2[XPOSTS][YPOSTS], // Immagine stirata
    lunghezza_mappa_int;


// Test dell'argomento
if ( argc == 1 )
        { printf("Devi dare un argomento\n");
          exit(1);
};

// Quale file  in input?
strcpy(infile,argv[1]);
if ((fp_in = fopen (infile, "r")) == NULL)
   { printf("Input file inesistente\n"); exit(); };

// File di output
strcpy(outfile,argv[1]);
strcat(outfile,"_sti.ras");


// n = XPOSTS * YPOSTS;

// Richiede il range di scansione
do {
  printf("\nInserire il range di scansione (150, 256, 384 mm): ");
  scanf("%d", &range);
  printf("\n");
}

// Controlla esattezza del range
while (range!=150 && range!=256 && range!=384);


/* L'incremento della x deve essere di
       293  per le scansioni di 150 mm
       500  per le scansioni di 256 mm
       750  per le scansioni di 384 mm
*/

switch (range) {

  case 150: { passo_della_i=293;
              break; }

  case 256: { passo_della_i=500;
              break; }

  case 384: { passo_della_i=750;
              break; }
}


// Definisce la dimensione della matrice e il range degli indici
z = imatrix( 0, XPOSTS - 1, 0, YPOSTS - 1);

header = strlen( argv[1] ) + 252;
for (j = 0; j < header; j++){
	fscanf(fp_in,"%c",&c);
}

// Matrice delle profondit
for (i=XPOSTS-1;i>=0;i--){
for (j=YPOSTS-1;j>=0;j--){
        fscanf(fp_in,"%2c",&u);
        z[i][j]=8*(int)u;

	if (z[i][j] > 262144)
		z[i][j] = - 65536 * 8 + z[i][j];
}};

// Ora abbiamo i dati e conosciamo il file di input
fclose (fp_in);

printf("Dati profondit prelevati\n");


// PRELEVA I DATI COLORE DAL FILE SUNRASTER

// File ras
strcpy(immfile,argv[1]);
strcat(immfile,".ras");


// Apre il file sunraster
if ((fp_imm = fopen (immfile, "r")) == NULL)
   { printf("Input file sun inesistente\n"); exit(); };

// Salta l'header che non interessa
for (j=0;j<28;j++){
	fscanf(fp_imm,"%c",&c);
}

// Legge la lunghezza della mappa
for (j=0;j<4;j++){
	fscanf(fp_imm,"%c",&lunghezza_mappa[j]);
}
lunghezza_mappa_int=lunghezza_mappa[3]+
                    lunghezza_mappa[2]*256+
                    lunghezza_mappa[1]*65536+
                    lunghezza_mappa[0]*16777216;


// Legge la mappa
for (contatore=0;contatore<lunghezza_mappa_int;contatore++){
	fscanf(fp_imm,"%c",&dato_char[contatore]);
        dato_colore[contatore]=dato_char[contatore];
}


// Matrice dell'immagine
for (i=XPOSTS-1;i>=0;i--){
for (j=YPOSTS-1;j>=0;j--){
	fscanf(fp_imm,"%c", &a);
        int_a=(int)a;
	immagine[i][j]=dato_colore[int_a];
}};


// Chiude il file ras
fclose (fp_imm);

printf("Dati colore prelevati\n");


// STIRAMENTO

// Inizializzazione matrice nuova immagine
for (j=0; j<YPOSTS; j++)
{
  for (i=0; i<XPOSTS; i++)
  {
    immagine_2[i][j] = 0;
  }
}
printf("Inizializzazione eseguita\n");

// Distanze righe

for (j=0; j<YPOSTS; j++) {
  distanza_vera_righe[XPOSTS/2-1][j] = 0;
  for (i=XPOSTS/2; i<XPOSTS; i++) {
    alfa_righe[i][j] = atan ((double)(z[i][j]-z[i-1][j])/(double)passo_della_i);
    distanza_righe[i][j]=(double)passo_della_i/cos(alfa_righe[i][j]);
    distanza_vera_righe[i][j]=distanza_vera_righe[i-1][j]+
      distanza_righe[i][j];
  }

  for (i=XPOSTS/2-2; i>=0; i--) {
    alfa_righe[i][j]=atan((double)(z[i][j]-z[i+1][j])/(double)passo_della_i);
    distanza_righe[i][j]=(double)passo_della_i/cos(alfa_righe[i][j]);
    distanza_vera_righe[i][j]=distanza_vera_righe[i+1][j]+
      distanza_righe[i][j];
  }
}

// Distanze colonne

for (i=0; i<XPOSTS; i++) {
  distanza_vera_colonne[i][YPOSTS/2-1] = 0;
  for (j=YPOSTS/2; j<YPOSTS; j++) {
    alfa_colonne[i][j]=atan((double)(z[i][j]-z[i][j-1])/(double)PASSO_DELLA_J);
    distanza_colonne[i][j]=(double)PASSO_DELLA_J/cos(alfa_colonne[i][j]);
    distanza_vera_colonne[i][j]=distanza_vera_colonne[i][j-1]+
      distanza_colonne[i][j];
  }

  for (j=YPOSTS/2-2; j>=0; j--) {
    alfa_colonne[i][j]=atan((double)(z[i][j]-z[i][j+1])/(double)PASSO_DELLA_J);
    distanza_colonne[i][j]=(double)PASSO_DELLA_J/cos(alfa_colonne[i][j]);
    distanza_vera_colonne[i][j]=distanza_vera_colonne[i][j+1]+
      distanza_colonne[i][j];
  }
}


// CREA LA NUOVA MATRICE DELL'IMMAGINE STIRATA


for (j=0; j<YPOSTS; j++)
{

  immagine_2[XPOSTS/2][j] = immagine[XPOSTS/2][j];
  immagine_2[XPOSTS/2-1][j] = immagine[XPOSTS/2-1][j];
  immagine_2[XPOSTS/2+1][j] = immagine[XPOSTS/2+1][j];

  for (i=XPOSTS/2; i<XPOSTS; i++)
  {
    for (contatore=XPOSTS/2; contatore<XPOSTS-1; contatore++)
    {
      if ( (((i-XPOSTS/2)*passo_della_i) >=
                         distanza_vera_righe[contatore][j]) &&
           (((i-XPOSTS/2)*passo_della_i) <=
                         distanza_vera_righe[contatore+1][j])) {

          immagine_2[i][j]=(immagine[contatore][j]*
                  distanza_righe[contatore+1][j]+
                  immagine[contatore+1][j]*distanza_righe[contatore][j])/
           (distanza_righe[contatore][j]+distanza_righe[contatore+1][j]);
      }

    }
  }


  for (i=XPOSTS/2-2; i>=0; i--)
  {
    for (contatore=XPOSTS/2-2; contatore>=0; contatore--)
    {
      if ( (((XPOSTS/2-i)*passo_della_i) >=
                          distanza_vera_righe[contatore][j]) &&
           (((XPOSTS/2-i)*passo_della_i) <=
                          distanza_vera_righe[contatore-1][j])) {

          immagine_2[i][j]=(immagine[contatore][j]*
                  distanza_righe[contatore-1][j]+
                  immagine[contatore-1][j]*distanza_righe[contatore][j])/
           (distanza_righe[contatore][j]+distanza_righe[contatore-1][j]);
         }

    }

  }
}

printf("Matrice nuova immagine pronta\n");


// SCRITTURA DEL FILE SUNRASTER

// Open file in scrittura
fp_out = fopen (outfile,"w");

// Numero magico del formato RAS
fprintf(fp_out,"%c%c%c%c",89,166,106,149);

// Numero di colonne
fprintf(fp_out,"%c%c%c%c",0,0,2,0);

// Numero di linee
fprintf(fp_out,"%c%c%c%c",0,0,2,0);

// Numero di bit per pixel
fprintf(fp_out,"%c%c%c%c",0,0,0,8);

// Numero dei byte dei dati immagine
fprintf(fp_out,"%c%c%c%c",0,4,0,0);

// Tipo
fprintf(fp_out,"%c%c%c%c",0,0,0,1);

// Tipo mappa
fprintf(fp_out,"%c%c%c%c",0,0,0,1);

// Lunghezza mappa
fprintf(fp_out,"%c%c%c%c",0,0,3,0);

// Scrittura mappa
for (j=0; j<3; j++) {
  for (i=0; i<256; i++)
    fprintf(fp_out,"%c",i);
}

// Scrittura matrice dell'immagine
for (j=0; j<YPOSTS; j++){
for (i=0; i<XPOSTS; i++){
  fprintf(fp_out,"%c",immagine_2[i][j]);
//  fprintf(fp_out,"%c",immagine[i][j]);
}}

// Chiusura file
fclose (fp_out);

}
